package lime.graphics;

import lime.graphics.ImageType;
import lime.graphics.utils.ImageCanvasUtil;
import Type;
import lime.graphics.utils.ImageDataUtil;
import lime.graphics.ImageChannel;
import lime.graphics.format.BMP;
import lime.graphics.format.JPEG;
import lime.graphics.format.PNG;
import lime.math.Rectangle;
import lime.math.Vector2;
import lime.system.Endian;
import lime.graphics.ImageBuffer;
import lime._backend.html5.HTML5HTTPRequest;
import lime.app.Future;
import haxe.crypto.BaseCode;
import haxe.io.Bytes;

@:jsRequire("lime/graphics/Image", "default")

extern class Image implements Dynamic {

	function new(?buffer:Dynamic, ?offsetX:Dynamic, ?offsetY:Dynamic, ?width:Dynamic, ?height:Dynamic, ?color:Dynamic, ?type:Dynamic);
	var buffer:Dynamic;
	var data:Dynamic;
	var dirty:Dynamic;
	var format:Dynamic;
	var height:Dynamic;
	var offsetX:Dynamic;
	var offsetY:Dynamic;
	var powerOfTwo:Dynamic;
	var premultiplied:Dynamic;
	var rect:Dynamic;
	
	var transparent:Dynamic;
	
	var version:Dynamic;
	var width:Dynamic;
	var x:Dynamic;
	var y:Dynamic;
	function clone():Dynamic;
	function colorTransform(rect:Dynamic, colorMatrix:Dynamic):Dynamic;
	function copyChannel(sourceImage:Dynamic, sourceRect:Dynamic, destPoint:Dynamic, sourceChannel:Dynamic, destChannel:Dynamic):Dynamic;
	function copyPixels(sourceImage:Dynamic, sourceRect:Dynamic, destPoint:Dynamic, ?alphaImage:Dynamic, ?alphaPoint:Dynamic, ?mergeAlpha:Dynamic):Dynamic;
	function encode(?format:Dynamic, ?quality:Dynamic):Dynamic;
	function fillRect(rect:Dynamic, color:Dynamic, ?format:Dynamic):Dynamic;
	function floodFill(x:Dynamic, y:Dynamic, color:Dynamic, ?format:Dynamic):Dynamic;
	function getColorBoundsRect(mask:Dynamic, color:Dynamic, ?findColor:Dynamic, ?format:Dynamic):Dynamic;
	function getPixel(x:Dynamic, y:Dynamic, ?format:Dynamic):Dynamic;
	function getPixel32(x:Dynamic, y:Dynamic, ?format:Dynamic):Dynamic;
	function getPixels(rect:Dynamic, ?format:Dynamic):Dynamic;
	function merge(sourceImage:Dynamic, sourceRect:Dynamic, destPoint:Dynamic, redMultiplier:Dynamic, greenMultiplier:Dynamic, blueMultiplier:Dynamic, alphaMultiplier:Dynamic):Dynamic;
	function resize(newWidth:Dynamic, newHeight:Dynamic):Dynamic;
	function scroll(x:Dynamic, y:Dynamic):Dynamic;
	function setPixel(x:Dynamic, y:Dynamic, color:Dynamic, ?format:Dynamic):Dynamic;
	function setPixel32(x:Dynamic, y:Dynamic, color:Dynamic, ?format:Dynamic):Dynamic;
	function setPixels(rect:Dynamic, bytePointer:Dynamic, ?format:Dynamic, ?endian:Dynamic):Dynamic;
	function threshold(sourceImage:Dynamic, sourceRect:Dynamic, destPoint:Dynamic, operation:Dynamic, threshold:Dynamic, ?color:Dynamic, ?mask:Dynamic, ?copySource:Dynamic, ?format:Dynamic):Dynamic;
	function __clipRect(r:Dynamic):Dynamic;
	function __fromBase64(base64:Dynamic, type:Dynamic, ?onload:Dynamic):Dynamic;
	function __fromBytes(bytes:Dynamic, ?onload:Dynamic):Dynamic;
	function __fromFile(path:Dynamic, ?onload:Dynamic, ?onerror:Dynamic):Dynamic;
	function __fromImageBuffer(buffer:Dynamic):Dynamic;
	function get_data():Dynamic;
	function set_data(value:Dynamic):Dynamic;
	function get_format():Dynamic;
	function set_format(value:Dynamic):Dynamic;
	function get_powerOfTwo():Dynamic;
	function set_powerOfTwo(value:Dynamic):Dynamic;
	function get_premultiplied():Dynamic;
	function set_premultiplied(value:Dynamic):Dynamic;
	function get_rect():Dynamic;
	function get_src():Dynamic;
	function set_src(value:Dynamic):Dynamic;
	function get_transparent():Dynamic;
	function set_transparent(value:Dynamic):Dynamic;
	static var __base64Chars:Dynamic;
	static var __base64Encoder:Dynamic;
	static function fromBase64(base64:Dynamic, type:Dynamic):Dynamic;
	static function fromBitmapData(bitmapData:Dynamic):Dynamic;
	static function fromBytes(bytes:Dynamic):Dynamic;
	static function fromCanvas(canvas:Dynamic):Dynamic;
	static function fromFile(path:Dynamic):Dynamic;
	static function fromImageElement(image:Dynamic):Dynamic;
	static function loadFromBase64(base64:Dynamic, type:Dynamic):Dynamic;
	static function loadFromBytes(bytes:Dynamic):Dynamic;
	static function loadFromFile(path:Dynamic):Dynamic;
	static function __base64Encode(bytes:Dynamic):Dynamic;
	static function __isGIF(bytes:Dynamic):Dynamic;
	static function __isJPG(bytes:Dynamic):Dynamic;
	static function __isPNG(bytes:Dynamic):Dynamic;
	static function __isWebP(bytes:Dynamic):Dynamic;


}