// Class: openfl.filters.DropShadowFilter

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $import = require("./../../import_stub").default;
var $extend = require("./../../extend_stub").default;
function openfl_filters_BitmapFilter() {return require("./../../openfl/filters/BitmapFilter");}
function openfl_geom_ColorTransform() {return require("./../../openfl/geom/ColorTransform");}
function lime_graphics_utils_ImageDataUtil() {return require("./../../lime/graphics/utils/ImageDataUtil");}
function Std() {return require("./../../Std");}

// Constructor

var DropShadowFilter = function(distance,angle,color,alpha,blurX,blurY,strength,quality,inner,knockout,hideObject) {
	if(hideObject == null) {
		hideObject = false;
	}
	if(knockout == null) {
		knockout = false;
	}
	if(inner == null) {
		inner = false;
	}
	if(quality == null) {
		quality = 1;
	}
	if(strength == null) {
		strength = 1;
	}
	if(blurY == null) {
		blurY = 4;
	}
	if(blurX == null) {
		blurX = 4;
	}
	if(alpha == null) {
		alpha = 1;
	}
	if(color == null) {
		color = 0;
	}
	if(angle == null) {
		angle = 45;
	}
	if(distance == null) {
		distance = 4;
	}
	this.distance = 4;
	this.blurY = 0;
	this.blurX = 0;
	this.angle = 45;
	(openfl_filters_BitmapFilter().default).call(this);
	this.__offsetX = 0;
	this.__offsetY = 0;
	this.__updateSize();
	this.set_distance(distance);
	this.set_angle(angle);
	this.set_color(color);
	this.set_alpha(alpha);
	this.set_blurX(blurX);
	this.set_blurY(blurY);
	this.set_strength(strength);
	this.set_quality(quality);
	this.set_inner(inner);
	this.set_knockout(knockout);
	this.set_hideObject(hideObject);
	this.__needSecondBitmapData = true;
	this.__preserveObject = !hideObject;
}

// Meta

DropShadowFilter.__name__ = ["openfl","filters","DropShadowFilter"];
DropShadowFilter.__super__ = (openfl_filters_BitmapFilter().default);
DropShadowFilter.prototype = $extend((openfl_filters_BitmapFilter().default).prototype, {
	clone: function() {
		return new DropShadowFilter(this.distance,this.angle,this.color,this.alpha,this.blurX,this.blurY,this.strength,this.quality,this.inner,this.knockout,this.hideObject);
	},
	__applyFilter: function(bitmapData,sourceBitmapData,sourceRect,destPoint) {
		var a = this.color >> 24 & 255;
		var r = this.color >> 16 & 255;
		var g = this.color >> 8 & 255;
		var b = this.color & 255;
		sourceBitmapData.colorTransform(sourceBitmapData.rect,new (openfl_geom_ColorTransform().default)(0,0,0,1,r,g,b,a));
		destPoint.x += this.__offsetX;
		destPoint.y += this.__offsetY;
		var finalImage = (lime_graphics_utils_ImageDataUtil().default).gaussianBlur(bitmapData.image,sourceBitmapData.image,sourceRect.__toLimeRectangle(),destPoint.__toLimeVector2(),this.blurX,this.blurY,this.quality,this.strength);
		if(finalImage == bitmapData.image) {
			return bitmapData;
		}
		return sourceBitmapData;
	},
	__updateSize: function() {
		this.__offsetX = (Std().default)["int"](this.distance * Math.cos(this.angle * Math.PI / 180));
		this.__offsetY = (Std().default)["int"](this.distance * Math.sin(this.angle * Math.PI / 180));
		this.__topExtension = Math.ceil((this.__offsetY < 0 ? -this.__offsetY : 0) + this.blurY);
		this.__bottomExtension = Math.ceil((this.__offsetY > 0 ? this.__offsetY : 0) + this.blurY);
		this.__leftExtension = Math.ceil((this.__offsetX < 0 ? -this.__offsetX : 0) + this.blurX);
		this.__rightExtension = Math.ceil((this.__offsetX > 0 ? this.__offsetX : 0) + this.blurX);
	},
	set_alpha: function(value) {
		if(value != this.alpha) {
			this.__renderDirty = true;
		}
		return this.alpha = value;
	},
	set_angle: function(value) {
		if(value != this.angle) {
			this.angle = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
	set_blurX: function(value) {
		if(value != this.blurX) {
			this.blurX = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
	set_blurY: function(value) {
		if(value != this.blurY) {
			this.blurY = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
	set_color: function(value) {
		if(value != this.color) {
			this.__renderDirty = true;
		}
		return this.color = value;
	},
	set_distance: function(value) {
		if(value != this.distance) {
			this.distance = value;
			this.__renderDirty = true;
			this.__updateSize();
		}
		return value;
	},
	set_hideObject: function(value) {
		if(value != this.hideObject) {
			this.__renderDirty = true;
			this.__preserveObject = !value;
		}
		return this.hideObject = value;
	},
	set_inner: function(value) {
		if(value != this.inner) {
			this.__renderDirty = true;
		}
		return this.inner = value;
	},
	set_knockout: function(value) {
		if(value != this.knockout) {
			this.__renderDirty = true;
		}
		return this.knockout = value;
	},
	set_quality: function(value) {
		if(value != this.quality) {
			this.__renderDirty = true;
		}
		return this.quality = value;
	},
	set_strength: function(value) {
		if(value != this.strength) {
			this.__renderDirty = true;
		}
		return this.strength = value;
	}
});
DropShadowFilter.prototype.__class__ = $hxClasses["openfl.filters.DropShadowFilter"] = DropShadowFilter;

// Init



// Statics




// Export

exports.default = DropShadowFilter;